
#include "IBRBillboardCloudTreeApplication.h"

IBRBillboardCloudTreeApplication::IBRBillboardCloudTreeApplication()
{
}

IBRBillboardCloudTreeApplication::~IBRBillboardCloudTreeApplication()
{	 
	// Gametools -- BUG: 31/03/2006
	//if (mLBBCManager)
	//{
	//	delete mLBBCManager;
	//}
}

void IBRBillboardCloudTreeApplication::initialize()
{
	for (unsigned int i = 0; i < 1; i++)
	{
		mSampleConfigFile = new LBBC::SampleConfigFile();
		mSampleConfigFile->load(mOpts.cfg);
		//this->setup(false);
		//mLBBCManager = new LBBC::LBBCManager();	
		//mLBBCManager->setSampleConfigFile(mSampleConfigFile);
		////mLBBCManager->loadSampleConfigFile(mOpts.cfg);
		//mLBBCManager->initialize();

		//if (mSampleConfigFile->getEntityDistributionGeneration())
		//{
		//	mLBBCManager->generateEntityDistribution();
		//}
		//else
		//{
		//	mLBBCManager->loadEntityDistribution();
		//}
		//if (mSampleConfigFile->getEntitySampleMeshGeneration())
		//{
		//	mLBBCManager->saveSingleEntity();
		//}
		//if (mSampleConfigFile->getEntityClustersGeneration())
		//{
		//	mLBBCManager->generateEntityClusters();
		//}
		//if (mSampleConfigFile->getBillboardCloudGeneration())
		//{
		//	mLBBCManager->generateBillboardCloud();
		//}

		//mLBBCManager->shutdown();
		//delete mLBBCManager;
		//mOgreBase->shutdown();		
		//delete mOgreBase;
		//----------------------------------------------------------------------------
		this->setup(true);
		mLBBCManager = new LBBC::LBBCManager();	
		mLBBCManager->setSampleConfigFile(mSampleConfigFile);	
		//mLBBCManager->loadSampleConfigFile(mOpts.cfg);
		mLBBCManager->initialize();
		mLBBCManager->loadBillboardCloudMergedXML();
		this->go();	
		for (unsigned int iFrameListenerMode = 0; iFrameListenerMode < mFrameListener->getNumFrameListenerModes(); iFrameListenerMode++)
		{
			mFrameListener->getFrameListenerMode(iFrameListenerMode)->destroyScene();
		}
		mRoot->shutdown();	
		mWindow->destroy();	
		delete mRoot;
		delete mSampleConfigFile;
	}


}

int IBRBillboardCloudTreeApplication::findCommandLineOpts(int numargs, char** argv, Ogre::UnaryOptionList& unaryOptList, 
						Ogre::BinaryOptionList& binOptList)
{
    int startIndex = 1;
    for (int i = 1; i < numargs; ++i)
    {
		Ogre::String tmp(argv[i]);
		if (Ogre::StringUtil::startsWith(tmp, "-"))
        {
			Ogre::UnaryOptionList::iterator ui = unaryOptList.find(argv[i]);
            if(ui != unaryOptList.end())
            {
                ui->second = true;
                ++startIndex;
                continue;
            }
			Ogre::BinaryOptionList::iterator bi = binOptList.find(argv[i]);
            if(bi != binOptList.end())
            {
                bi->second = argv[i+1];
                startIndex += 2;
                ++i;
                continue;
            }

            // Invalid option
			std::cout<<"Invalid option "<<tmp<<std::endl;

        }
    }
    return startIndex;
}

void IBRBillboardCloudTreeApplication::help()
{
	std::cout<<"Please specify the parameter: -cfg sample.cfg"<<std::endl;
}

void IBRBillboardCloudTreeApplication::parseArgs(int numArgs, char **args)
{
	if (numArgs < 2)
    {
        help();
        exit(-1);
    }
	else
	{
		Ogre::UnaryOptionList unOpt;
		Ogre::BinaryOptionList binOpt;

		binOpt["-cfg"] = "";
	    
		int startIndex = findCommandLineOpts(numArgs, args, unOpt, binOpt);
		Ogre::UnaryOptionList::iterator ui;
		Ogre::BinaryOptionList::iterator bi;
		
		bi = binOpt.find("-cfg");
		if (!bi->second.empty())
		{
			mOpts.cfg = bi->second;	
		}	
	}
}

void IBRBillboardCloudTreeApplication::createFrameListener(void)
{
	mFrameListener = new IBRBillboardCloudTreeFrameListener(mWindow);
	
	mSceneMgr = mFrameListener->getEnabledFrameListenerMode()->getSceneManager();	

	{
		LBBC::BillboardCloudTextureViewMode *anotherFrameListenerMode;
		anotherFrameListenerMode = new LBBC::BillboardCloudTextureViewMode(mWindow,mFrameListener->getNumFrameListenerModes());
		anotherFrameListenerMode->chooseSceneManager();
		anotherFrameListenerMode->createCamera();
		anotherFrameListenerMode->createViewports();
		//anotherFrameListenerMode->setEntityName(Ogre::String(mSampleConfigFile->getEntityClustersMeshPrefixName() + "Merged.mesh"));
		anotherFrameListenerMode->setTextureAtlasSize(mSampleConfigFile->getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasSize());
		anotherFrameListenerMode->setTextureSize(mSampleConfigFile->getBillboardCloudDiffuseColorMergedBillboardsTextureSize());
		anotherFrameListenerMode->setTextureAtlasBitRange(mSampleConfigFile->getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasBitRange());
		anotherFrameListenerMode->setTextureAtlasName(mSampleConfigFile->getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasPrefixName());
		anotherFrameListenerMode->setTextureAtlasFolder(mSampleConfigFile->getBillboardCloudFolder());
		anotherFrameListenerMode->createScene();
		mFrameListener->addFrameListenerMode(anotherFrameListenerMode);
	}

	//{
	//	LBBC::ClusterViewMode *anotherFrameListenerMode;
	//	anotherFrameListenerMode = new LBBC::ClusterViewMode(mWindow,mFrameListener->getNumFrameListenerModes());
	//	anotherFrameListenerMode->chooseSceneManager();
	//	anotherFrameListenerMode->createCamera();
	//	anotherFrameListenerMode->createViewports();
	//	anotherFrameListenerMode->createScene();
	//	mFrameListener->addFrameListenerMode(anotherFrameListenerMode);
	//}

	//{
	//	LBBC::BillboardViewMode *anotherFrameListenerMode;
	//	anotherFrameListenerMode = new LBBC::BillboardViewMode(mWindow,mFrameListener->getNumFrameListenerModes());
	//	anotherFrameListenerMode->chooseSceneManager();
	//	anotherFrameListenerMode->createCamera();
	//	anotherFrameListenerMode->createViewports();
	//	anotherFrameListenerMode->createScene();
	//	mFrameListener->addFrameListenerMode(anotherFrameListenerMode);
	//}

	{
		LBBC::EntityTextureAtlasViewMode *textureAtlasFrameListenerMode;
		textureAtlasFrameListenerMode = new LBBC::EntityTextureAtlasViewMode(mWindow,mFrameListener->getNumFrameListenerModes());
		textureAtlasFrameListenerMode->chooseSceneManager();
		textureAtlasFrameListenerMode->createCamera();
		textureAtlasFrameListenerMode->createViewports();
		textureAtlasFrameListenerMode->setTextureAtlasSize(mSampleConfigFile->getBillboardCloudDiffuseColorEntityTextureAtlasSize());
		textureAtlasFrameListenerMode->setTextureAtlasBitRange(mSampleConfigFile->getBillboardCloudDiffuseColorEntityTextureAtlasBitRange());
		textureAtlasFrameListenerMode->setTextureAtlasNumSamples(mSampleConfigFile->getBillboardCloudDiffuseColorEntityTextureAtlasNumSamples());
		textureAtlasFrameListenerMode->setTextureName(mSampleConfigFile->getBillboardCloudDiffuseColorEntityTexturePrefixName());
		textureAtlasFrameListenerMode->setTextureAtlasName(mSampleConfigFile->getBillboardCloudDiffuseColorEntityTextureAtlasPrefixName());
		textureAtlasFrameListenerMode->setTextureAtlasFolder(mSampleConfigFile->getBillboardCloudFolder());

		mFrameListener->addFrameListenerMode(textureAtlasFrameListenerMode);
		textureAtlasFrameListenerMode->createScene();
	}

	mFrameListener->removeFrameListenerMode(0);
	mFrameListener->setEnabledFrameListenerMode(0);

    mRoot->addFrameListener(mFrameListener);
}