#include "LBBCSampleConfigFile.h"

namespace LBBC {

SampleConfigFile::SampleConfigFile(): Ogre::ConfigFile()
{
}
	
SampleConfigFile::~SampleConfigFile()
{
}

Ogre::String SampleConfigFile::getEntitySampleMaterialPrefixName()
{
	return getSetting("Entity Sample Material Prefix Name");
}

Ogre::String SampleConfigFile::getEntitySampleMeshPrefixName()
{
	return getSetting("Entity Sample Mesh Prefix Name");
}

bool SampleConfigFile::getEntityDistributionGeneration()
{
	return Ogre::StringConverter::parseBool(getSetting("Entity Distribution Generation"));
}

bool SampleConfigFile::getEntityDistributionMerged()
{
	return Ogre::StringConverter::parseBool(getSetting("Entity Distribution Merged"));
}

Ogre::String SampleConfigFile::getEntityDistributionSplittedMaterialPrefixName()
{
	return getSetting("Entity Distribution Splitted Material Prefix Name");
}

Ogre::String SampleConfigFile::getEntityDistributionMergedMaterialPrefixName()
{
	return getSetting("Entity Distribution Merged Material Prefix Name");
}

Ogre::String SampleConfigFile::getEntityDistributionFolder()
{
	return getSetting("Entity Distribution Folder");
}

Ogre::String SampleConfigFile::getEntityDistributionXMLPrefixName()
{
	return getSetting("Entity Distribution XML Prefix Name");
}

Ogre::String SampleConfigFile::getEntitiesFolder()
{
	return getSetting("Entities Folder");
}


Ogre::String SampleConfigFile::getEntitiesMeshPrefixName()
{
	return getSetting("Entities Mesh Prefix Name");
}

Ogre::String SampleConfigFile::getBillboardCloudXMLPrefixName()
{
	return getSetting("Billboard Cloud XML Prefix Name");
}

bool SampleConfigFile::getEntitySampleMeshGeneration()
{
	return Ogre::StringConverter::parseBool(getSetting("Entity Sample Mesh Generation"));
}

bool SampleConfigFile::getEntityClustersGeneration()
{
	return Ogre::StringConverter::parseBool(getSetting("Entity Clusters Generation"));
}

float SampleConfigFile::getEntityClustersAlpha()
{
	return Ogre::StringConverter::parseReal(getSetting("Entity Clusters Alpha"));
}

unsigned int SampleConfigFile::getEntityClustersMaxClusters()
{
	return Ogre::StringConverter::parseInt(getSetting("Entity Clusters MaxClusters"));
}

unsigned int SampleConfigFile::getEntityClustersNumIterations()
{
	return Ogre::StringConverter::parseInt(getSetting("Entity Clusters NumIterations"));
}

bool SampleConfigFile::getEntityClustersMergedClusters()
{
	return Ogre::StringConverter::parseBool(getSetting("Entity Clusters Merged Clusters"));
}

bool SampleConfigFile::getEntityClustersSplittedClusters()
{
	return Ogre::StringConverter::parseBool(getSetting("Entity Clusters Splitted Clusters"));
}

bool SampleConfigFile::getEntityDistributionSplitted()
{
	return Ogre::StringConverter::parseBool(getSetting("Entity Distribution Splitted"));
}

bool SampleConfigFile::getBillboardCloudGeneration()
{
	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Generation"));
}

bool SampleConfigFile::getBillboardCloudMergedBillboards()
{
	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Merged Billboards"));
}

bool SampleConfigFile::getBillboardCloudSplittedBillboards()
{
	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Splitted Billboards"));
}

Ogre::String SampleConfigFile::getEntityClustersFolder()
{
	return getSetting("Entity Clusters Folder");
}

Ogre::String SampleConfigFile::getEntityClustersMeshPrefixName()
{
	return getSetting("Entity Clusters Mesh Prefix Name");
}

Ogre::String SampleConfigFile::getEntityClustersMergedMaterialPrefixName()
{
	return getSetting("Entity Clusters Merged Material Prefix Name");
}

Ogre::String SampleConfigFile::getEntityClustersSplittedMaterialPrefixName()
{
	return getSetting("Entity Clusters Splitted Material Prefix Name");
}

Ogre::String SampleConfigFile::getBillboardCloudFolder()
{
	return getSetting("Billboard Cloud Folder");
}

Ogre::String SampleConfigFile::getBillboardCloudMeshPrefixName()
{
	return getSetting("Billboard Cloud Mesh Prefix Name");
}

Ogre::String SampleConfigFile::getBillboardCloudBillboardMaterialPrefixName()
{
	return getSetting("Billboard Cloud Billboard Material Prefix Name");
}

Ogre::String SampleConfigFile::getBillboardCloudBillboardGroupMaterialPrefixName()
{
	return getSetting("Billboard Cloud Billboard Group Material Prefix Name");
}

Ogre::String SampleConfigFile::getBillboardCloudBillboardTextureUnit0PrefixName()
{
	return getSetting("Billboard Cloud Billboard Texture Unit 0 Prefix Name");
}

Ogre::String SampleConfigFile::getBillboardCloudBillboardGroupTextureUnit0PrefixName()
{
	return getSetting("Billboard Cloud Billboard Group Texture Unit 0 Prefix Name");
}

Ogre::String SampleConfigFile::getBillboardCloudIndirectBillboardGroupTextureAtlasPrefixName()
{
	return getSetting("Billboard Cloud Indirect Billboard Group Texture Atlas Prefix Name");
}

unsigned int SampleConfigFile::getBillboardCloudDiffuseColorEntityTextureAtlasBitRange()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Diffuse Color Entity Texture Atlas Bit Range"));
}

unsigned int SampleConfigFile::getBillboardCloudDiffuseColorBillboardGroupTextureSize()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Diffuse Color Billboard Group Texture Size"));
}

unsigned int SampleConfigFile::getBillboardCloudGroups()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Groups"));
}

unsigned int SampleConfigFile::getBillboardCloudIndirectBillboardGroupTextureAtlasBitRange()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Indirect Billboard Group Texture Atlas Bit Range"));
}

unsigned int SampleConfigFile::getBillboardCloudIndirectBillboardGroupTextureAtlasSize()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Indirect Billboard Group Texture Atlas Size"));
}

unsigned int SampleConfigFile::getBillboardCloudIndirectBillboardGroupTextureSize()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Indirect Billboard Group Texture Size"));
}

unsigned int SampleConfigFile::getBillboardCloudDiffuseColorBillboardGroupTextureAtlasSize()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Diffuse Color Billboard Group Texture Atlas Size"));
}

bool SampleConfigFile::getBillboardCloudDiffuseColorBillboardGroupTextureAtlasGeneration()
{
	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Diffuse Color Billboard Group Texture Atlas Generation"));
}

bool SampleConfigFile::getBillboardCloudIndirectBillboardGroupTextureAtlasGeneration()
{
	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Indirect Billboard Group Texture Atlas Generation"));
}

bool SampleConfigFile::getBillboardCloudGroupedBillboards()
{
	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Grouped Billboards"));
}

bool SampleConfigFile::getBillboardCloudDiffuseColorEntityTextureAtlasGeneration()
{
	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Diffuse Color Entity Texture Atlas Generation"));
}

Ogre::String SampleConfigFile::getBillboardCloudDiffuseColorEntityTexturePrefixName()
{
	return getSetting("Billboard Cloud Diffuse Color Entity Texture Prefix Name");
}

Ogre::String SampleConfigFile::getBillboardCloudDiffuseColorEntityTextureAtlasPrefixName()
{
	return getSetting("Billboard Cloud Diffuse Color Entity Texture Atlas Prefix Name");
}

unsigned int SampleConfigFile::getBillboardCloudDiffuseColorEntityTextureAtlasSize()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Diffuse Color Entity Texture Atlas Size"));
}

unsigned int SampleConfigFile::getBillboardCloudDiffuseColorEntityTextureAtlasNumSamples()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Diffuse Color Entity Texture Atlas NumSamples"));
}

bool SampleConfigFile::getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasGeneration()
{
	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Diffuse Color Merged Billboards Texture Atlas Generation"));
}

Ogre::String SampleConfigFile::getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasPrefixName()
{
	return getSetting("Billboard Cloud Diffuse Color Merged Billboards Texture Atlas Prefix Name");
}

unsigned int SampleConfigFile::getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasBitRange()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Diffuse Color Merged Billboards Texture Atlas Bit Range"));
}

unsigned int SampleConfigFile::getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasSize()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Diffuse Color Merged Billboards Texture Atlas Size"));
}

unsigned int SampleConfigFile::getBillboardCloudDiffuseColorMergedBillboardsTextureSize()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Diffuse Color Merged Billboards Texture Size"));
}

bool SampleConfigFile::getBillboardCloudIndirectMergedBillboardsTextureAtlasGeneration()
{
	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Indirect Merged Billboards Texture Atlas Generation"));
}

Ogre::String SampleConfigFile::getBillboardCloudIndirectMergedBillboardsTextureAtlasPrefixName()
{
	return getSetting("Billboard Cloud Indirect Merged Billboards Texture Atlas Prefix Name");
}

unsigned int SampleConfigFile::getBillboardCloudIndirectMergedBillboardsTextureAtlasBitRange()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Indirect Merged Billboards Texture Atlas Bit Range"));
}

unsigned int SampleConfigFile::getBillboardCloudIndirectMergedBillboardsTextureAtlasSize()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Indirect Merged Billboards Texture Atlas Size"));
}

unsigned int SampleConfigFile::getBillboardCloudIndirectMergedBillboardsTextureSize()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Indirect Merged Billboards Texture Size"));
}

}
